## cube2font 1.3.1

=== src/Makefile ===
APPNAME=redeclipse
APPCLIENT=reclient
APPSERVER=reserver

#CXXFLAGS= -ggdb3
CXXFLAGS= -O3 -fomit-frame-pointer
override CXXFLAGS+= -Wall -fsigned-char -fno-exceptions -fno-rtti

PLATFORM= $(shell uname -s)
PLATFORM_SUFFIX=_native

INCLUDES= -Ishared -Iengine -Igame -Ienet/include

STRIP=
ifeq (,$(findstring -g,$(CXXFLAGS)))
ifeq (,$(findstring -pg,$(CXXFLAGS)))
	STRIP=strip
endif
endif

MV=mv

ifneq (,$(findstring MINGW,$(PLATFORM)))
WINDRES= windres
ifneq (,$(findstring 64,$(PLATFORM)))
WINLIB=lib64
WINBIN=../bin64
override CXX+= -m64
override WINDRES+= -F pe-x86-64
else
WINLIB=lib
WINBIN=../bin
override CXX+= -m32
override WINDRES+= -F pe-i386
endif
ifneq (,$(findstring TDM,$(PLATFORM)))
STD_LIBS=
else
STD_LIBS= -static-libgcc -static-libstdc++
endif
CLIENT_INCLUDES= $(INCLUDES) -Iinclude
CLIENT_LIBS= -mwindows $(STD_LIBS) -L$(WINBIN) -L$(WINLIB) -lSDL -lSDL_image -lSDL_mixer -lzlib1 -lopengl32 -lenet -lws2_32 -lwinmm
else
CLIENT_INCLUDES= $(INCLUDES) -I/usr/X11R6/include `sdl-config --cflags`
CLIENT_LIBS= -Lenet/.libs -lenet -L/usr/X11R6/lib -lX11 `sdl-config --libs` -lSDL_image -lSDL_mixer -lz -lGL
endif
ifeq ($(PLATFORM),Linux)
CLIENT_LIBS+= -lrt
endif
CLIENT_OBJS= \
	shared/crypto.o \
	shared/geom.o \
	shared/stream.o \
	shared/tools.o \
	shared/zip.o \
	engine/bih.o \
	engine/blend.o \
	engine/blob.o \
	engine/client.o \
	engine/command.o \
	engine/console.o \
	engine/decal.o \
	engine/dynlight.o \
	engine/glare.o \
	engine/grass.o \
	engine/irc.o	\
	engine/lightmap.o \
	engine/main.o \
	engine/material.o \
	engine/menus.o \
	engine/movie.o \
	engine/normal.o \
	engine/octa.o \
	engine/octaedit.o \
	engine/octarender.o \
	engine/physics.o \
	engine/pvs.o \
	engine/rendergl.o \
	engine/rendermodel.o \
	engine/renderparticles.o \
	engine/rendersky.o \
	engine/rendertext.o \
	engine/renderva.o \
	engine/server.o \
	engine/serverbrowser.o \
	engine/shader.o \
	engine/shadowmap.o \
	engine/sound.o \
	engine/texture.o \
	engine/ui.o \
	engine/water.o \
	engine/world.o \
	engine/worldio.o \
	game/ai.o \
	game/client.o \
	game/capture.o \
	game/defend.o \
	game/bomber.o \
	game/entities.o \
	game/game.o \
	game/hud.o \
	game/physics.o \
	game/projs.o \
	game/scoreboard.o \
	game/server.o \
	game/waypoint.o \
	game/weapons.o

CLIENT_PCH= shared/cube.h.gch engine/engine.h.gch

ifneq (,$(findstring MINGW,$(PLATFORM)))
SERVER_INCLUDES= -DSTANDALONE $(INCLUDES) -Iinclude
SERVER_LIBS= -mwindows $(STD_LIBS) -L$(WINBIN) -L$(WINLIB) -lzlib1 -lenet -lws2_32 -lwinmm
else
SERVER_INCLUDES= -DSTANDALONE $(INCLUDES)
SERVER_LIBS= -Lenet/.libs -lenet -lz
endif
SERVER_OBJS= \
	shared/crypto-standalone.o \
	shared/geom-standalone.o \
	shared/stream-standalone.o \
	shared/tools-standalone.o \
	engine/command-standalone.o \
	engine/irc-standalone.o \
	engine/master-standalone.o \
	engine/server-standalone.o \
	game/server-standalone.o

default: all

enet/Makefile:
	cd enet; ./configure --enable-shared=no --enable-static=yes

libenet: enet/Makefile
	$(MAKE) -C enet/ all

clean-enet: enet/Makefile
	$(MAKE) -C enet/ clean

clean: clean-client clean-server

clean-client:
	@rm -fv $(CLIENT_PCH) $(CLIENT_OBJS) $(APPCLIENT)

clean-server:
	@rm -fv $(SERVER_OBJS) $(APPSERVER)

%.h.gch: %.h
	$(CXX) $(CXXFLAGS) -o $(subst .h.gch,.tmp.h.gch,$@) $(subst .h.gch,.h,$@)
	$(MV) $(subst .h.gch,.tmp.h.gch,$@) $@

%-standalone.o: %.cpp
	$(CXX) $(CXXFLAGS) -c -o $@ $(subst -standalone.o,.cpp,$@)

$(CLIENT_OBJS): CXXFLAGS += $(CLIENT_INCLUDES)
$(filter shared/%,$(CLIENT_OBJS)): $(filter shared/%,$(CLIENT_PCH))
$(filter engine/%,$(CLIENT_OBJS)): $(filter engine/%,$(CLIENT_PCH))
$(filter game/%,$(CLIENT_OBJS)): $(filter game/%,$(CLIENT_PCH))

$(SERVER_OBJS): CXXFLAGS += $(SERVER_INCLUDES)

ifneq (,$(findstring MINGW,$(PLATFORM)))
client: $(CLIENT_OBJS)
	$(WINDRES) -i $(APPNAME).rc -J rc -o $(APPNAME).res -O coff 
	$(CXX) $(CXXFLAGS) -o $(WINBIN)/$(APPCLIENT).exe $(APPNAME).res $(CLIENT_OBJS) $(CLIENT_LIBS)

server: $(SERVER_OBJS)
	$(WINDRES) -i $(APPNAME).rc -J rc -o $(APPNAME).res -O coff 
	$(CXX) $(CXXFLAGS) -o $(WINBIN)/$(APPSERVER).exe $(APPNAME).res $(SERVER_OBJS) $(SERVER_LIBS)

install-client: client
ifneq (,$(STRIP))
	$(STRIP) $(WINBIN)/$(APPCLIENT).exe
endif

install-server: server
ifneq (,$(STRIP))
	$(STRIP) $(WINBIN)/$(APPSERVER).exe
endif
else
client: libenet $(CLIENT_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $(APPCLIENT) $(CLIENT_OBJS) $(CLIENT_LIBS)
ifneq (,$(STRIP))
	$(STRIP) $(APPCLIENT)
endif

server: libenet $(SERVER_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $(APPSERVER) $(SERVER_OBJS) $(SERVER_LIBS)
ifneq (,$(STRIP))
	$(STRIP) $(APPSERVER)
endif

install-client: client
	install -d ../bin
	install -m 755 $(APPCLIENT) ../bin/$(APPCLIENT)$(PLATFORM_SUFFIX)

install-server: server
	install -d ../bin
	install -m 755 $(APPSERVER) ../bin/$(APPSERVER)$(PLATFORM_SUFFIX)

shared/cube2font.o: shared/cube2font.c
	$(CXX) $(CXXFLAGS) -c -o $@ $< `freetype-config --cflags`

cube2font: shared/cube2font.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o cube2font shared/cube2font.o `freetype-config --libs` -lz

install-cube2font: cube2font
	install -d ../bin
	install -m 755 cube2font ../bin/cube2font
endif

install: install-client install-server

depend:
	makedepend -Y -Ishared -Iengine -Igame $(subst .o,.cpp,$(CLIENT_OBJS))
	makedepend -a -o-standalone.o -Y -Ishared -Iengine -Igame -DSTANDALONE $(subst -standalone.o,.cpp,$(SERVER_OBJS))
	makedepend -a -o.h.gch -Y -Ishared -Iengine -Igame $(subst .h.gch,.h,$(CLIENT_PCH))

all: client server

include system-install.mk
include dist.mk

engine/engine.h.gch: shared/cube.h.gch

# DO NOT DELETE

shared/crypto.o: shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/crypto.o: shared/ents.h shared/iengine.h shared/igame.h
shared/geom.o: shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/geom.o: shared/ents.h shared/iengine.h shared/igame.h
shared/stream.o: shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/stream.o: shared/ents.h shared/iengine.h shared/igame.h
shared/tools.o: shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/tools.o: shared/ents.h shared/iengine.h shared/igame.h
shared/zip.o: shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/zip.o: shared/ents.h shared/iengine.h shared/igame.h
engine/bih.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/bih.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/bih.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/bih.o: engine/lightmap.h engine/bih.h engine/texture.h engine/model.h
engine/bih.o: engine/varray.h
engine/blend.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/blend.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/blend.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/blend.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/blend.o: engine/model.h engine/varray.h
engine/blob.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/blob.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/blob.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/blob.o: engine/lightmap.h engine/bih.h engine/texture.h engine/model.h
engine/blob.o: engine/varray.h
engine/client.o: engine/engine.h shared/cube.h shared/tools.h
engine/client.o: shared/command.h shared/geom.h shared/ents.h
engine/client.o: shared/iengine.h shared/igame.h engine/irc.h engine/sound.h
engine/client.o: engine/world.h engine/octa.h engine/lightmap.h engine/bih.h
engine/client.o: engine/texture.h engine/model.h engine/varray.h
engine/command.o: engine/engine.h shared/cube.h shared/tools.h
engine/command.o: shared/command.h shared/geom.h shared/ents.h
engine/command.o: shared/iengine.h shared/igame.h engine/irc.h engine/sound.h
engine/command.o: engine/world.h engine/octa.h engine/lightmap.h engine/bih.h
engine/command.o: engine/texture.h engine/model.h engine/varray.h
engine/console.o: engine/engine.h shared/cube.h shared/tools.h
engine/console.o: shared/command.h shared/geom.h shared/ents.h
engine/console.o: shared/iengine.h shared/igame.h engine/irc.h engine/sound.h
engine/console.o: engine/world.h engine/octa.h engine/lightmap.h engine/bih.h
engine/console.o: engine/texture.h engine/model.h engine/varray.h
engine/decal.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/decal.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/decal.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/decal.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/decal.o: engine/model.h engine/varray.h
engine/dynlight.o: engine/engine.h shared/cube.h shared/tools.h
engine/dynlight.o: shared/command.h shared/geom.h shared/ents.h
engine/dynlight.o: shared/iengine.h shared/igame.h engine/irc.h
engine/dynlight.o: engine/sound.h engine/world.h engine/octa.h
engine/dynlight.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/dynlight.o: engine/model.h engine/varray.h
engine/glare.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/glare.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/glare.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/glare.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/glare.o: engine/model.h engine/varray.h engine/rendertarget.h
engine/grass.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/grass.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/grass.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/grass.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/grass.o: engine/model.h engine/varray.h
engine/irc.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/irc.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/irc.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/irc.o: engine/lightmap.h engine/bih.h engine/texture.h engine/model.h
engine/irc.o: engine/varray.h
engine/lightmap.o: engine/engine.h shared/cube.h shared/tools.h
engine/lightmap.o: shared/command.h shared/geom.h shared/ents.h
engine/lightmap.o: shared/iengine.h shared/igame.h engine/irc.h
engine/lightmap.o: engine/sound.h engine/world.h engine/octa.h
engine/lightmap.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/lightmap.o: engine/model.h engine/varray.h
engine/main.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/main.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/main.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/main.o: engine/lightmap.h engine/bih.h engine/texture.h engine/model.h
engine/main.o: engine/varray.h
engine/material.o: engine/engine.h shared/cube.h shared/tools.h
engine/material.o: shared/command.h shared/geom.h shared/ents.h
engine/material.o: shared/iengine.h shared/igame.h engine/irc.h
engine/material.o: engine/sound.h engine/world.h engine/octa.h
engine/material.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/material.o: engine/model.h engine/varray.h
engine/menus.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/menus.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/menus.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/menus.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/menus.o: engine/model.h engine/varray.h
engine/movie.o: engine/engine.h shared/cube.h shared/tools.h shared/command.h
engine/movie.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/movie.o: engine/irc.h engine/sound.h engine/world.h engine/octa.h
engine/movie.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/movie.o: engine/model.h engine/varray.h
engine/normal.o: engine/engine.h shared/cube.h shared/tools.h
engine/normal.o: shared/command.h shared/geom.h shared/ents.h
engine/normal.o: shared/iengine.h shared/igame.h engine/irc.h engine/sound.h

## cube2font 1.2

=== debian/changelog ===
cube2font (1.2-2) unstable; urgency=low

  * Fix build-dependencies
    - Add libfreetype6-dev, fixes Ubuntu FTBFS
    - Remove superfluous SDL depends and add just libpng-dev

 -- Martin Erik Werner <martinerikwerner@gmail.com>  Tue, 14 Feb 2012 02:01:14 +0100

cube2font (1.2-1) unstable; urgency=low

  * Initial release (Closes: #651567)
    - Built from a subset of the Red Eclipse source
  * Added debian/patches/build-with-debug-symbols.patch

 -- Martin Erik Werner <martinerikwerner@gmail.com>  Tue, 20 Dec 2011 18:55:11 +0100

=== debian/control ===
Source: cube2font
Section: graphics
Priority: optional
Uploaders: Martin Erik Werner <martinerikwerner@gmail.com>
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: debhelper (>= 8), libfreetype6-dev, libpng-dev
Standards-Version: 3.9.2
Homepage: http://www.redeclipse.net
Vcs-Git: git://git.debian.org/pkg-games/cube2font.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/cube2font.git;a=summary

Package: cube2font
Architecture: any
Pre-Depends: dpkg (>= 1.15.6~)
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: utility program for creating font bitmaps for Cube Engine games
 cube2font is a utility program designed to create font bitmaps for Cube
 Engine games, it works by taking a Truetype font and building it into a
 set of coordinates in an image. cube2font is an improved version of the
 previous TTF2Font, supporting a much larger range of characters.

Package: cube2font-dbg
Section: debug
Architecture: any
Priority: extra
Pre-Depends: dpkg (>= 1.15.6~)
Depends: cube2font (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for cube2font
 This package contains the debugging symbols for the font bitmap creation tool
 cube2font.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --sourcedirectory=src

override_dh_auto_clean:
	dh_clean

override_dh_auto_build:
	dh_auto_build -- cube2font

override_dh_strip:
	dh_strip -pcube2font --dbg-package=cube2font-dbg

override_dh_auto_install:
	make -C src/ system-install-cube2font DESTDIR=../debian/cube2font \
		prefix=/usr

override_dh_builddeb:
	dh_builddeb -- -Zxz

VER=$(shell dpkg-parsechangelog | sed -rne 's/^Version: ([^-]+).*/\1/p')
DIR=cube2font-$(VER).orig
TAR=cube2font_$(VER).orig.tar.bz2
get-orig-source:
	uscan --noconf --force-download --download-current-version --destdir=.
	rm -rf $(DIR)
	tar -xf $(TAR)
	rm -f $(TAR)
	mv redeclipse/ $(DIR)
	find $(DIR) -mindepth 1 -not -name src \
				-not -name shared \
				-not -name install \
				-not -name nix \
				-not -name cube2font.1 \
				-not -name Makefile \
				-not -name system-install.mk \
				-not -wholename $(DIR)/license.txt \
				-not -name cube2font.c \
				-not -name redeclipse.cbp \
				-delete
	BZIP2="-9" tar -cj --owner root --group root --mode a+rX \
		-f $(TAR) $(DIR)
	rm -rf $(DIR)

=== debian/watch ===
version=3
http://sf.net/redeclipse/redeclipse_([0-9\.]+)_linux_bsd\.tar\.bz2

## cube2font 1.3.1

=== debian/changelog ===
cube2font (1.3.1-2build1) bionic; urgency=high

  * No change rebuild to pick up -fPIE compiler default

 -- Balint Reczey <rbalint@ubuntu.com>  Tue, 03 Apr 2018 12:18:05 +0000

cube2font (1.3.1-2) unstable; urgency=low

  * Upload to unstable
  * Drop dpkg Pre-Depends (upgrades from old Ubuntu versions not relevant)
  * Standards-Version 3.9.4 (no changes)

 -- Martin Erik Werner <martinerikwerner@gmail.com>  Sat, 11 May 2013 12:11:52 +0200

cube2font (1.3.1-1) experimental; urgency=low

  * New upstream release
  * dh compat level 9
  * zlib1g-dev build-dep replaces libpng-dev
  * Enable dpkg-buildflags
  * Use xz orig tarball compression
  * Standards-Version 3.9.3
    - Set final DEP-3 Format: link
  * Added debian/patches/makefile-install.patch
    - Fix for broken make install target

 -- Martin Erik Werner <martinerikwerner@gmail.com>  Sat, 01 Sep 2012 21:12:16 +0200

=== debian/control ===
Source: cube2font
Section: graphics
Priority: optional
Uploaders: Martin Erik Werner <martinerikwerner@gmail.com>
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: debhelper (>= 9), libfreetype6-dev, zlib1g-dev
Standards-Version: 3.9.4
Homepage: http://www.redeclipse.net
Vcs-Git: git://git.debian.org/pkg-games/cube2font.git
Vcs-Browser: http://git.debian.org/?p=pkg-games/cube2font.git;a=summary

Package: cube2font
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: utility program for creating font bitmaps for Cube Engine games
 cube2font is a utility program designed to create font bitmaps for Cube
 Engine games, it works by taking a Truetype font and building it into a
 set of coordinates in an image. cube2font is an improved version of the
 previous TTF2Font, supporting a much larger range of characters.

Package: cube2font-dbg
Section: debug
Architecture: any
Priority: extra
Depends: cube2font (= ${binary:Version}), ${misc:Depends}
Description: debugging symbols for cube2font
 This package contains the debugging symbols for the font bitmap creation tool
 cube2font.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --sourcedirectory=src

override_dh_auto_clean:

override_dh_auto_build:
	dh_auto_build -- \
		CXXFLAGS="$(CXXFLAGS) $(CPPFLAGS)" \
		LDFLAGS="$(LDFLAGS)" \
		cube2font

override_dh_strip:
	dh_strip -pcube2font --dbg-package=cube2font-dbg

override_dh_auto_install:
	make -C src/ system-install-cube2font DESTDIR=../debian/cube2font \
		prefix=/usr

override_dh_builddeb:
	dh_builddeb -- -Zxz

VER=$(shell dpkg-parsechangelog | sed -rne 's/^Version: ([^-]+).*/\1/p')
DIR=cube2font-$(VER).orig
UTAR=cube2font_$(VER).orig.tar.bz2
TAR=cube2font_$(VER).orig.tar.xz
get-orig-source:
	uscan --noconf --force-download --download-current-version --destdir=.
	rm -rf $(DIR)
	tar -xf $(UTAR)
	rm -f $(UTAR)
	mv redeclipse/ $(DIR)
	find $(DIR) -mindepth 1 -not -name src \
				-not -name shared \
				-not -name doc \
				-not -name man \
				-not -name cube2font.1 \
				-not -name Makefile \
				-not -name system-install.mk \
				-not -name dist.mk \
				-not -wholename $(DIR)/license.txt \
				-not -name cube2font.c \
				-not -name redeclipse.cbp \
				-delete
	XZ="-6" tar --create --xz --owner root --group root --mode a+rX \
                -f $(TAR) $(DIR)
	rm -rf $(DIR)

## cube2font 1.5.1

=== src/Makefile ===
APPNAME=redeclipse
APPCLIENT=$(APPNAME)
APPSERVER=$(APPNAME)_server

#CXXFLAGS= -ggdb3
CXXFLAGS= -O3 -fomit-frame-pointer -ffast-math
override CXXFLAGS+= -Wall -fsigned-char -fno-exceptions -fno-rtti

PLATFORM= $(shell gcc -dumpmachine)

ifeq (,$(PLATFORM_BIN))
ifneq (,$(findstring arm,$(PLATFORM)))
PLATFORM_BIN=arm
else
ifneq (,$(findstring 64,$(PLATFORM)))
PLATFORM_BIN=amd64
else
PLATFORM_BIN=x86
endif
endif
endif

ifeq (,$(INSTDIR))
INSTDIR=../bin/$(PLATFORM_BIN)
endif

TOOLSET_PREFIX=
ifneq (,$(findstring cross,$(PLATFORM)))
ifneq (,$(findstring 64,$(PLATFORM)))
TOOLSET_PREFIX=x86_64-w64-mingw32-
else
TOOLSET_PREFIX=i686-w64-mingw32-
endif
CXX=g++
endif

CXX_TEMP:=$(CXX)
override CXX=$(TOOLSET_PREFIX)$(CXX_TEMP)

INCLUDES= -I. -Ishared -Iengine -Igame -Ienet/include


STRIP=
ifeq (,$(findstring -g,$(CXXFLAGS)))
ifeq (,$(findstring -pg,$(CXXFLAGS)))
	STRIP=strip
endif
endif
STRIP_TEMP:=$(STRIP)
override STRIP=$(TOOLSET_PREFIX)$(STRIP_TEMP)

MV=mv
CP=cp
MKDIR=mkdir -p

ifneq (,$(findstring mingw,$(PLATFORM)))
APPMODIFIER=_windows
BIN_SUFFIX=.exe
WINDRES=windres
WINDRES_TEMP:=$(WINDRES)
WINLIB=lib/$(PLATFORM_BIN)
WINDLL=../bin/$(PLATFORM_BIN)
override WINDRES=$(TOOLSET_PREFIX)$(WINDRES_TEMP)
ifneq (,$(findstring 64,$(PLATFORM)))
override WINDRES+= -F pe-x86-64
else
override WINDRES+= -F pe-i386
endif
STD_LIBS= -static-libgcc -static-libstdc++
CLIENT_INCLUDES= $(INCLUDES) -Iinclude
CLIENT_LIBS= -mwindows $(STD_LIBS) -L$(WINDLL) -L$(WINLIB) -lSDL -lSDL_image -lSDL_mixer -lzlib1 -lopengl32 -lenet -lws2_32 -lwinmm
else
APPMODIFIER=
ifneq (,$(findstring linux,$(PLATFORM)))
BIN_SUFFIX=_linux
else
ifneq (,$(findstring bsd,$(PLATFORM)))
BIN_SUFFIX=_bsd
else
BIN_SUFFIX=_native
endif
endif
CLIENT_INCLUDES= $(INCLUDES) -I/usr/X11R6/include `sdl-config --cflags`
CLIENT_LIBS= -Lenet -lenet -L/usr/X11R6/lib -lX11 `sdl-config --libs` -lSDL_image -lSDL_mixer -lz -lGL
endif
ifneq (,$(findstring linux,$(PLATFORM)))
CLIENT_LIBS+= -lrt
else
ifneq (,$(findstring gnu,$(PLATFORM)))
CLIENT_LIBS+= -lrt
endif
endif
CLIENT_OBJS= \
	shared/crypto.o \
	shared/geom.o \
	shared/stream.o \
	shared/tools.o \
	shared/zip.o \
	engine/bih.o \
	engine/blend.o \
	engine/blob.o \
	engine/client.o \
	engine/command.o \
	engine/console.o \
	engine/decal.o \
	engine/dynlight.o \
	engine/glare.o \
	engine/grass.o \
	engine/irc.o	\
	engine/lightmap.o \
	engine/main.o \
	engine/material.o \
	engine/menus.o \
	engine/movie.o \
	engine/normal.o \
	engine/octa.o \
	engine/octaedit.o \
	engine/octarender.o \
	engine/physics.o \
	engine/pvs.o \
	engine/rendergl.o \
	engine/rendermodel.o \
	engine/renderparticles.o \
	engine/rendersky.o \
	engine/rendertext.o \
	engine/renderva.o \
	engine/server.o \
	engine/serverbrowser.o \
	engine/shader.o \
	engine/shadowmap.o \
	engine/sound.o \
	engine/texture.o \
	engine/ui.o \
	engine/water.o \
	engine/world.o \
	engine/worldio.o \
	game/ai.o \
	game/client.o \
	game/capture.o \
	game/defend.o \
	game/bomber.o \
	game/entities.o \
	game/game.o \
	game/hud.o \
	game/physics.o \
	game/projs.o \
	game/scoreboard.o \
	game/server.o \
	game/waypoint.o \
	game/weapons.o

CLIENT_PCH= shared/cube.h.gch engine/engine.h.gch

ifneq (,$(findstring mingw,$(PLATFORM)))
SERVER_INCLUDES= -DSTANDALONE $(INCLUDES) -Iinclude
SERVER_LIBS= -mwindows $(STD_LIBS) -L$(WINDLL) -L$(WINLIB) -lzlib1 -lenet -lws2_32 -lwinmm
else
SERVER_INCLUDES= -DSTANDALONE $(INCLUDES)
SERVER_LIBS= -Lenet -lenet -lz
endif
SERVER_OBJS= \
	shared/crypto-standalone.o \
	shared/geom-standalone.o \
	shared/stream-standalone.o \
	shared/tools-standalone.o \
	shared/zip-standalone.o \
	engine/command-standalone.o \
	engine/irc-standalone.o \
	engine/master-standalone.o \
	engine/server-standalone.o \
	game/server-standalone.o

LIBENET= enet/libenet.a

all:

default: all

clean-enet:
	$(MAKE) -C enet clean

clean-client:
	@rm -fv $(CLIENT_PCH) $(CLIENT_OBJS) $(APPCLIENT)$(BIN_SUFFIX)

clean-server:
	@rm -fv $(SERVER_OBJS) $(APPSERVER)$(BIN_SUFFIX)

clean: clean-enet clean-client clean-server

%.h.gch: %.h
	$(CXX) $(CXXFLAGS) -x c++-header -o $(subst .h.gch,.tmp.h.gch,$@) $(subst .h.gch,.h,$@)
	$(MV) $(subst .h.gch,.tmp.h.gch,$@) $@

%-standalone.o: %.cpp
	$(CXX) $(CXXFLAGS) -c -o $@ $(subst -standalone.o,.cpp,$@)

$(CLIENT_OBJS): CXXFLAGS += $(CLIENT_INCLUDES)
$(filter shared/%,$(CLIENT_OBJS)): $(filter shared/%,$(CLIENT_PCH))
$(filter engine/%,$(CLIENT_OBJS)): $(filter engine/%,$(CLIENT_PCH))
$(filter game/%,$(CLIENT_OBJS)): $(filter game/%,$(CLIENT_PCH))

$(SERVER_OBJS): CXXFLAGS += $(SERVER_INCLUDES)

$(APPCLIENT)_windows$(BIN_SUFFIX): $(CLIENT_OBJS)
	$(WINDRES) -i $(APPNAME).rc -J rc -o $(APPNAME).res -O coff
	$(CXX) $(CXXFLAGS) -o $@ $(APPNAME).res $(CLIENT_OBJS) $(CLIENT_LIBS)

$(APPSERVER)_windows$(BIN_SUFFIX): $(SERVER_OBJS)
	$(WINDRES) -i $(APPNAME).rc -J rc -o $(APPNAME).res -O coff
	$(CXX) $(CXXFLAGS) -o $@ $(APPNAME).res $(SERVER_OBJS) $(SERVER_LIBS)

$(APPCLIENT)$(BIN_SUFFIX): $(LIBENET) $(CLIENT_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $(CLIENT_OBJS) $(CLIENT_LIBS)

$(APPSERVER)$(BIN_SUFFIX): $(LIBENET) $(SERVER_OBJS)
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $(SERVER_OBJS) $(SERVER_LIBS)

client: $(APPCLIENT)$(APPMODIFIER)$(BIN_SUFFIX)

server: $(APPSERVER)$(APPMODIFIER)$(BIN_SUFFIX)

$(INSTDIR)/%$(BIN_SUFFIX): %$(APPMODIFIER)$(BIN_SUFFIX)
	$(MKDIR) $(INSTDIR)
	$(CP) $< $@
ifneq (,$(STRIP))
	$(STRIP) $@
endif

install-client: $(INSTDIR)/$(APPCLIENT)$(BIN_SUFFIX)

install-server: $(INSTDIR)/$(APPSERVER)$(BIN_SUFFIX)

ifeq (,$(findstring mingw,$(PLATFORM)))
shared/cube2font.o: shared/cube2font.c
	$(CXX) $(CXXFLAGS) -c -o $@ $< `freetype-config --cflags`

cube2font: shared/cube2font.o
	$(CXX) $(CXXFLAGS) $(LDFLAGS) -o $@ $< `freetype-config --libs` -lz

install-cube2font: cube2font
	$(MKDIR) $(INSTDIR)
	install -m 755 $< $(INSTDIR)/$<
endif

install: install-client install-server

$(LIBENET):
	$(MAKE) -C enet

depend:
	makedepend -Y -I. -Ishared -Iengine -Igame $(subst .o,.cpp,$(CLIENT_OBJS))
	makedepend -a -o-standalone.o -Y -I. -Ishared -Iengine -Igame -DSTANDALONE $(subst -standalone.o,.cpp,$(SERVER_OBJS))
	makedepend -a -o.h.gch -Y -I. -Ishared -Iengine -Igame $(subst .h.gch,.h,$(CLIENT_PCH))

all: client server

include system-install.mk
include dist.mk
include wiki.mk

engine/engine.h.gch: version.h shared/cube.h.gch

# DO NOT DELETE

shared/crypto.o: version.h shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/crypto.o: shared/ents.h shared/iengine.h shared/igame.h
shared/geom.o: version.h shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/geom.o: shared/ents.h shared/iengine.h shared/igame.h
shared/stream.o: version.h shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/stream.o: shared/ents.h shared/iengine.h shared/igame.h
shared/tools.o: version.h shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/tools.o: shared/ents.h shared/iengine.h shared/igame.h
shared/zip.o: version.h shared/cube.h shared/tools.h shared/command.h shared/geom.h
shared/zip.o: shared/ents.h shared/iengine.h shared/igame.h
engine/bih.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/bih.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/bih.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/bih.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/bih.o: engine/model.h engine/varray.h
engine/blend.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/blend.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/blend.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/blend.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/blend.o: engine/model.h engine/varray.h
engine/blob.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/blob.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/blob.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/blob.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/blob.o: engine/model.h engine/varray.h
engine/client.o: engine/engine.h version.h shared/cube.h shared/tools.h
engine/client.o: shared/command.h shared/geom.h shared/ents.h
engine/client.o: shared/iengine.h shared/igame.h engine/irc.h engine/sound.h
engine/client.o: engine/world.h engine/glexts.h engine/octa.h
engine/client.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/client.o: engine/model.h engine/varray.h
engine/command.o: engine/engine.h version.h shared/cube.h shared/tools.h
engine/command.o: shared/command.h shared/geom.h shared/ents.h
engine/command.o: shared/iengine.h shared/igame.h engine/irc.h engine/sound.h
engine/command.o: engine/world.h engine/glexts.h engine/octa.h
engine/command.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/command.o: engine/model.h engine/varray.h
engine/console.o: engine/engine.h version.h shared/cube.h shared/tools.h
engine/console.o: shared/command.h shared/geom.h shared/ents.h
engine/console.o: shared/iengine.h shared/igame.h engine/irc.h engine/sound.h
engine/console.o: engine/world.h engine/glexts.h engine/octa.h
engine/console.o: engine/lightmap.h engine/bih.h engine/texture.h
engine/console.o: engine/model.h engine/varray.h
engine/decal.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/decal.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/decal.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/decal.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/decal.o: engine/model.h engine/varray.h
engine/dynlight.o: engine/engine.h version.h shared/cube.h shared/tools.h
engine/dynlight.o: shared/command.h shared/geom.h shared/ents.h
engine/dynlight.o: shared/iengine.h shared/igame.h engine/irc.h
engine/dynlight.o: engine/sound.h engine/world.h engine/glexts.h
engine/dynlight.o: engine/octa.h engine/lightmap.h engine/bih.h
engine/dynlight.o: engine/texture.h engine/model.h engine/varray.h
engine/glare.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/glare.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/glare.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/glare.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/glare.o: engine/model.h engine/varray.h engine/rendertarget.h
engine/grass.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/grass.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/grass.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/grass.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/grass.o: engine/model.h engine/varray.h
engine/irc.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/irc.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/irc.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/irc.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/irc.o: engine/model.h engine/varray.h
engine/lightmap.o: engine/engine.h version.h shared/cube.h shared/tools.h
engine/lightmap.o: shared/command.h shared/geom.h shared/ents.h
engine/lightmap.o: shared/iengine.h shared/igame.h engine/irc.h
engine/lightmap.o: engine/sound.h engine/world.h engine/glexts.h
engine/lightmap.o: engine/octa.h engine/lightmap.h engine/bih.h
engine/lightmap.o: engine/texture.h engine/model.h engine/varray.h
engine/main.o: engine/engine.h version.h shared/cube.h shared/tools.h shared/command.h
engine/main.o: shared/geom.h shared/ents.h shared/iengine.h shared/igame.h
engine/main.o: engine/irc.h engine/sound.h engine/world.h engine/glexts.h
engine/main.o: engine/octa.h engine/lightmap.h engine/bih.h engine/texture.h
engine/main.o: engine/model.h engine/varray.h
engine/material.o: engine/engine.h version.h shared/cube.h shared/tools.h

=== debian/changelog ===
cube2font (1.5.1-1) unstable; urgency=medium

  * Team upload.

  [ Martin Erik Werner ]
  * New minor upstream release
    - Fixes 0-border behaviour
    - Drop makefile-install.patch
  * Canonicalize VCS-urls
  * Imported Upstream version 1.5.1

  [ Reiner Herrmann ]
  * Point Vcs-* URLs to salsa.
  * Use pkg-config for finding libraries. (Closes: #892330)
  * Replace -dbg package with -dbgsym.
  * Update debhelper to compat level 11.
  * Update URLs in d/copyright.
  * Use https in Homepage field.
  * Bump Standards-Version to 4.2.1.

 -- Reiner Herrmann <reiner@reiner-h.de>  Fri, 19 Oct 2018 19:59:20 +0200

=== debian/control ===
Source: cube2font
Section: graphics
Priority: optional
Uploaders: Martin Erik Werner <martinerikwerner@gmail.com>
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Build-Depends: debhelper (>= 11), libfreetype6-dev, pkg-config, zlib1g-dev
Standards-Version: 4.2.1
Homepage: https://www.redeclipse.net
Vcs-Git: https://salsa.debian.org/games-team/cube2font.git
Vcs-Browser: https://salsa.debian.org/games-team/cube2font

Package: cube2font
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: utility program for creating font bitmaps for Cube Engine games
 cube2font is a utility program designed to create font bitmaps for Cube
 Engine games, it works by taking a Truetype font and building it into a
 set of coordinates in an image. cube2font is an improved version of the
 previous TTF2Font, supporting a much larger range of characters.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@ --sourcedirectory=src

override_dh_auto_clean:

override_dh_auto_build:
	dh_auto_build -- \
		CXXFLAGS="$(CXXFLAGS) $(CPPFLAGS) -ffast-math" \
		LDFLAGS="$(LDFLAGS) -Wl,--as-needed" \
		appnamefull="" \
		appversion="" \
		weapon-names="" \
		cube2font

override_dh_strip:
	dh_strip --dbgsym-migration='cube2font-dbg (<< 1.5.1-1~)'

override_dh_auto_install:
	make -C src/ system-install-cube2font DESTDIR=$(CURDIR)/debian/cube2font \
		appnamefull="" \
		appversion="" \
		weapon-names="" \
		prefix=/usr

DIR=cube2font-$(DEB_VERSION_UPSTREAM).orig
get-orig-source:
	uscan --noconf --rename --force-download --download-current-version --destdir=.
	rm -rf $(DIR)
	tar -xf cube2font_$(DEB_VERSION_UPSTREAM).orig.tar.gz
	rm -f cube2font_$(DEB_VERSION_UPSTREAM).orig.tar.gz
	mv base-$(DEB_VERSION_UPSTREAM) $(DIR)
	find $(DIR) -mindepth 1 -not -name src \
				-not -name shared \
				-not -name doc \
				-not -name man \
				-not -name cube2font.1 \
				-not -wholename $(DIR)/src/Makefile \
				-not -name system-install.mk \
				-not -name dist.mk \
				-not -name wiki.mk \
				-not -wholename $(DIR)/doc/license.txt \
				-not -name cube2font.c \
				-not -name redeclipse.cbp \
				-delete
	XZ="-6" tar --create --xz --owner root --group root --mode a+rX \
		-f cube2font_$(DEB_VERSION_UPSTREAM).orig.tar.xz $(DIR)
	rm -rf $(DIR)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/redeclipse-$1\.tar\.gz/ \
  https://github.com/red-eclipse/base/tags .*/v?(\d\S*)\.tar\.gz
